REBOL []

print rejoin [{Welcome to HTMLMyCheckbook version 0.1.} newline newline {What is the name of the account file you wish to view as an .html file?}]

file-name: input

read-file: reform [rejoin [{accounts: read %} file-name]]
print read-file
do read-file

parsed-accounts: parse/all accounts "^-"

number-of-accounts: make integer! parsed-accounts/2
number-of-categories: make integer! parsed-accounts/3

position: 5

;----------------------------
; SKIP PROPRIETARY DATA BEGIN
;----------------------------

for leap-frog-categories 1 number-of-categories 1 [
	find-target: reform [ rejoin [{number-to-jump: make integer! parsed-accounts/} position]]
	print find-target
	do find-target
	position: position + (number-to-jump + 2)
	leap-frog-categories: leap-frog-categories + 1
]

position: (position + (number-of-accounts * 8)) + 1

;----------------------------
; SKIP PROPRIETARY DATA END
;----------------------------

;----------------------------
; MAKE ACCOUNT OBJECTS
;----------------------------

for make-account-objects 1 number-of-accounts 1 [
	account-to-object: reform [rejoin
	[{account} make-account-objects {: make object! [
		account-name: } reform [rejoin [{parsed-accounts/} position ]]
		{ institution: } reform [rejoin [{parsed-accounts/} (position + 1) ]]
		{ account-number: } reform [rejoin [{parsed-accounts/} (position + 2) ]]
		{ number-of-transactions: make integer! } reform [rejoin [{parsed-accounts/} (position + 9) ]]
	{]}
	]
	]
	print account-to-object
	do account-to-object
	position: position + 12
	make-account-objects: make-account-objects + 1
]

;--------
; OUTPUT
;--------

stuff-to-write: make string! 100000

for output-info 1 number-of-accounts 1 [

	make-account-values: copy []
	acct-name: copy []
	inst: copy []
	acct-num: copy []
	account-header: copy []
	make-loop-number: copy []
	loop-number: copy []

	make-account-values: reform [rejoin [
		{acct-name: } reform [rejoin [{account} output-info {/account-name}]]
		{ inst: } reform [rejoin [{account} output-info {/institution}]]
		{ acct-num: } reform [rejoin [{account} output-info {/account-number}]]
	]]

	print make-account-values
	do make-account-values

	account-header: reform [rejoin [acct-name tab inst tab acct-num tab newline newline {Check Number} tab {Date} tab {Pay to the order of} tab {Amount} tab {Category} tab {Sub-Category} tab {Memo} newline]]

	append stuff-to-write account-header

	make-loop-number: reform [rejoin [
		{loop-number: } reform [rejoin [{account} output-info {/number-of-transactions}]]
	]]

	do make-loop-number
	print make-loop-number

	loop loop-number [

		make-transaction-values: copy []
		check-number: copy []
		date: copy []
		pay-to: copy []
		amount: copy []
		category: copy []
		sub-category: copy []
		memo: copy []
		transaction-info: copy []

		make-transaction-values: reform [rejoin [
			{check-number: } reform [rejoin [{parsed-accounts/} (position + 5)]]
			{ date: } reform [rejoin [{parsed-accounts/} (position + 2)]]
			{ pay-to: } reform [rejoin [{parsed-accounts/} (position + 6)]]
			{ amount: } reform [rejoin [{parsed-accounts/} position]]
			{ category: } reform [rejoin [{parsed-accounts/} (position + 7)]]
			{ sub-category: } reform [rejoin [{parsed-accounts/} (position + 8)]]
			{ memo: } reform [rejoin [{parsed-accounts/} (position + 9)]]
		]]

		do make-transaction-values

		transaction-info: reform [rejoin [check-number tab date tab pay-to tab amount tab category tab sub-category tab memo newline]]

		append stuff-to-write transaction-info

		position: position + 12
	]

	append stuff-to-write rejoin [newline newline newline]

	output-info: output-info + 1

	
]

write-file: reform [rejoin [{write %} file-name {.txt stuff-to-write}]]

do write-file
